#!/bin/sh

if [ $# -eq 0 ]
then echo "syntax: $0 color"
     echo " 1 Black"
     echo " 2 Medium Green"
     echo " 3 Light Green"
     echo " 4 Dark blue"
     echo " 5 Light blue"
     echo " 6 Dark Red (brown)"
     echo " 7 Cyan"
     echo " 8 Medium Red"
     echo " 9 Light Red (Pink/orange)"
     echo " 10 Dark Yellow (Yellow)"
     echo " 11 Light Yellow (Yellow + Light Grey)"
     echo " 12 Dark Green"
     echo " 13 Magenta"
     echo " 14 Grey (Light Grey)"
     echo " 15 White"
     exit 1
fi

COLOR=$1

rm -rf pack dump
rm final.rom

mkdir pack
mkdir dump

C=0
for G in `grep -v '#' list | awk '{ print $1 }'`
do
  cp "../../../../roms/${G}" pack/
  C=`expr $C + 1`
done
if [ $C -ne 63 ]
then echo "Number of roms is not 63 but $C"
     exit 1
fi

cd pack
# generation du fichier game.dat

N=0

GAME_DAT=../game.dat
GAME_LST=../game.txt
echo > ${GAME_DAT}
echo "List of games: " > ${GAME_LST}

for G in *rom
do
  F=`basename "${G}" .rom`
  echo "$F" >> ${GAME_LST}
  F=`echo $F | cut -c1-14 | sed -e 's/-/ /g'`
  echo $F | awk -v N=${N} '{ printf( "case %d : strcpy( buffer, \"%-14s\"); break;\n", N, $0 ); }' >> ${GAME_DAT}
  ID=`echo $N | awk '{ printf( "%02d\n", $1 ) }'`
  ../pad32k ${G} ../dump/${ID}.dump
  N=`expr $N + 1`
done
cd ..

echo "game.dat validation"
gvim --nofork game.dat
cp game.dat ../
make -C .. clean
make -C .. all COLOR=$COLOR

./pad32k ../result.rom dump/63.dump

cat dump/[0-2]*dump dump/3[0-1]*dump > final-part1.rom
cat dump/3[2-9]*dump dump/[4-6]*dump > final-part2.rom

echo "The file final.rom is ready for eprom flash"
